Bug 23175 - Use of <cite> in <blockquote> has conflicting semantics
Use of <cite> in <blockquote> has conflicting semantics
Status: RESOLVED FIXED
Product: HTML WG
Classification: Unclassified
Component: HTML5 spec
unspecified
All All
: P2 normal
: ---
Assigned To: steve faulkner
HTML WG Bugzilla archive list
:
Depends on:
Blocks: 23314
  Show dependency treegraph
 
Reported: 2013-09-06 14:07 UTC by Josh Tumath
Modified: 2014-01-16 15:10 UTC (History)
7 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Josh Tumath 2013-09-06 14:07:42 UTC
The recent changes in the definitions of <cite> and <blockquote> have been a massive improvement. However, consider the following example:

  <blockquote>
    Who is your favourite doctor (in <cite>Doctor Who</cite>)?
    - <cite>John Smith</cite>
  </blockquote>

We can see that, in that blockquote, there are two different uses for <cite>. The first represents the title of a work, and the second represents the source of the quote. Therefore, there is no semantic way to differentiate between the former and latter meaning.

Therefore, I'd like to propose that it should be a requirement for authors to specify the source of a quote inside the <footer> element; rather than this just being optional.

Note that this is not a problem with inline quotes, because the <cite> would be outside the quote tags:

  <q>Who is your favourite doctor (in <cite>Doctor Who</cite>)?</q>
  - <cite>John Smith</cite>
Comment 1 Leif Halvard Silli 2013-09-06 14:33:07 UTC
(In reply to Josh Tumath from comment #0)

Thanks for taking up a very relevant problem.

> Note that this is not a problem with inline quotes, because the <cite> would
> be outside the quote tags:
> 
>   <q>Who is your favourite doctor (in <cite>Doctor Who</cite>)?</q>
>   - <cite>John Smith</cite>

Actually, <cite> is not forbidden inside <q>: 

“Contexts in which this element can be used: Where phrasing content is expected.“

http://www.w3.org/html/wg/drafts/html/master/single-page.html#the-cite-element

One should think that <cite> inside <q> will increase in use now that <cite> is allowed inside <blockquote>. After all, it is the same pattern. And this use should remain permitted (as long as <cite> is allowed in <blockquote>, at least).
Comment 2 Leif Halvard Silli 2013-09-06 14:41:34 UTC
(In reply to Josh Tumath from comment #0)

>   <blockquote>
>     Who is your favourite doctor (in <cite>Doctor Who</cite>)?
>     - <cite>John Smith</cite>
>   </blockquote>
> 
> We can see that, in that blockquote, there are two different uses for
> <cite>. The first represents the title of a work, and the second represents
> the source of the quote.

The way I, at first, read this was that the example represents a quotation from another work who is, in turn, quoting yet another work. 

Is that correct?
Comment 3 Leif Halvard Silli 2013-09-06 14:43:51 UTC
(In reply to Leif Halvard Silli from comment #2)
> (In reply to Josh Tumath from comment #0)

> Is that correct?

(The alternative reading is that Smith is the source (read: the author) of that work.)
Comment 4 Leif Halvard Silli 2013-09-06 14:59:14 UTC
As an alternative to requiring <footer>:

<blockquote>
  <blockquote>
  Who is your favourite doctor (in <cite>Doctor Who</cite>)?
  </blockquote>
  - <cite>John Smith</cite>
</blockquote>
Comment 5 Josh Tumath 2013-09-06 15:17:57 UTC
(In reply to Leif Halvard Silli from comment #2)
> The way I, at first, read this was that the example represents a quotation
> from another work who is, in turn, quoting yet another work. 
> 
> Is that correct?

That is why I have raised this issue. That's actually incorrect. The example is a (fictitious) quotation from the source "John Smith", who cites the work "Doctor Who" in his utterance. That's the meaning I intended, but a different meaning could be interpreted, like you said.

(In reply to Leif Halvard Silli from comment #1)
> Actually, <cite> is not forbidden inside <q>: 
> 
> “Contexts in which this element can be used: Where phrasing content is
> expected.“
> 
> http://www.w3.org/html/wg/drafts/html/master/single-page.html#the-cite-
> element
> 
> One should think that <cite> inside <q> will increase in use now that <cite>
> is allowed inside <blockquote>. After all, it is the same pattern. And this
> use should remain permitted (as long as <cite> is allowed in <blockquote>,
> at least).

Yes, that would indeed be fine. However, my point is that (like in my blockquote example), if you use <cite> to show the source of the quote, but place that <cite> within the quote, that <cite>'s content would be treated as part of the quote, and could be interpreted as a part of the speaker's utterance when that actually might not intended.
Comment 6 Josh Tumath 2013-09-06 15:24:27 UTC
(In reply to Leif Halvard Silli from comment #4)
> As an alternative to requiring <footer>:
> 
> <blockquote>
>   <blockquote>
>   Who is your favourite doctor (in <cite>Doctor Who</cite>)?
>   </blockquote>
>   - <cite>John Smith</cite>
> </blockquote>

I disagree. :) In that scenario, you're suggesting that the name "John Smith" was spoken in a quote by someone else. However, by adding the <footer> element around the cite, it is clear that it is part of the quote's "metadata"; we can separate it from the actual quote.
Comment 7 Leif Halvard Silli 2013-09-06 15:56:27 UTC
(In reply to Josh Tumath from comment #5)

> > Is that correct?

> [ snip ]That's actually incorrect. The example
> is a (fictitious) quotation from the source "John Smith", who cites the work
> "Doctor Who" in his utterance. That's the meaning I intended, but a
> different meaning could be interpreted, like you said.

So, I must then take you to *not* have meant that “John Smith” is (quoting myself) “yet another work”. Which means that you have used <cite> incorrectly. 

It seems to me that the problem you are raising would be a problem regardless where the <cite> was used. You are discussing the question about how to discern between <cite> as reference to a “source” (such as a person of the name ”John Smith”) versus <cite> as reference to a “work”.

(Citing the spec: “The cite element represents a reference to a creative work.”)

The answer to *your* problem is: Don’t use <cite> to indicate “source”. Use <cite> correctly: Use it to indicate a “works”.
Comment 8 Leif Halvard Silli 2013-09-06 16:05:02 UTC
(In reply to Josh Tumath from comment #6)

> I disagree. :) In that scenario, you're suggesting that the name "John
> Smith" was spoken in a quote by someone else.

How do you justify that claim?

>  However, by adding the
> <footer> element around the cite, it is clear that it is part of the quote's
> "metadata"; we can separate it from the actual quote.

Well, it is also possible to quote a <footer>, so there is no guarantee that <footer> isn’t itself quoted. That said, I can agree that it probably increases the chances that the content of the footer is an “about text” rather than a part of the actual quote.
Comment 9 steve faulkner 2013-09-06 16:13:14 UTC
hi Josh, Leif, am following discussion, but have no chance to think about it today, paid work gets in the way.

I draw your attention to http://oli.jp/2011/blockquote/#using-footer and ensuing as it has a bearing on this discussion.

I also think that it is a rabbit hole to consider the markup in quotes being taken from the source.
Comment 10 Josh Tumath 2013-09-06 16:35:35 UTC
(In reply to Leif Halvard Silli from comment #7)
> You are discussing the question about
> how to discern between <cite> as reference to a “source” (such as a person
> of the name ”John Smith”) versus <cite> as reference to a “work”.

The question I am discussing is: how can a <cite> showing the source of the quote be differentiated from the quote if it is included within the quote.

> (Citing the spec: “The cite element represents a reference to a creative
> work.”)
> 
> The answer to *your* problem is: Don’t use <cite> to indicate “source”. Use
> <cite> correctly: Use it to indicate a “works”.

The rest of the definition in the spec is "It must include either the title of the work or the name of the author (person, people or organization) of the work". Quotations are considered "works". If they were not works, then the spec would not use examples where <cite> is used to show the author of a quote.

(In reply to steve faulkner from comment #9)
> I draw your attention to http://oli.jp/2011/blockquote/#using-footer and
> ensuing as it has a bearing on this discussion.

If inline changes to the quote are now allowed, then I suppose this is a non-issue.
Comment 11 Leif Halvard Silli 2013-09-06 18:21:27 UTC
(In reply to Josh Tumath from comment #10)
> The question I am discussing is: how can a <cite> showing the source of the
> quote be differentiated from the quote if it is included within the quote.

OK. 

> Quotations are considered "works".

1 - 0 to you. :-)
Comment 12 Leif Halvard Silli 2013-09-06 19:00:40 UTC
(In reply to steve faulkner from comment #9)

> I also think that it is a rabbit hole to consider the markup in quotes being
> taken from the source.

(By ”from the source” you no doubt meant “from the source code“.)

I agree that it would be wrong of authors (as well as of consumers) to *expect* that the content of a <blockquote> uses the same markup as the original work from where the quote is taken.

My mention of <footer> was a “what if it happens” kind of statement. E.g. if, using Firefox, I copy something and paste into BlueGriffon, then the markup of the original source will be included, including <footer> - and <cite>. And since it is WYSIWYG, the author might not realize it.

Regarding https://twitter.com/stevefaulkner/status/375934134234796032, then

* may be spec should say that authors SHOULD remove <footer> (and possibly other confusing markup, like <a> etc) that are not relevant in the new context where the quote is placed etc? 

* may be you should have a discussion of the ”meta issue” - stating that the quotation does not need - and often shouldn’t be - a verbatim copy of the original source. For inspiration, the spec, in the <p> element definition, includes has a good meta discussion about what a paragraph, in HTML, is. May be a similar discussion about what a quotation is, in HTML, could be included as well:

   “The solution is to realise that a paragraph, in HTML terms, is
    not a logical concept, but a structural one.”
Comment 13 Andrew 2013-09-07 15:10:58 UTC
When I originally suggested the amendment to allow cite without footer, the only issue I foresaw was this one, that you would be unable to cell if a cite was part of the quote or an actual cite. I discounted it for two reasons:

1. footer in blockquote has exactly the same issue.
2. people are already using cite in blockquote. I presumed this is because people were citing the blockquote but maybe they were just quoting things with cites in already?
Comment 14 github bugzilla bot 2013-09-16 09:18:34 UTC
Commit pushed to master at https://github.com/w3c/html

https://github.com/w3c/html/commit/fa08747b366b40e9942d29f071dccb33ea5529d2
what to do when cite in quoted source

fix for bug 23175
Comment 15 steve faulkner 2013-11-05 10:28:55 UTC
comment from bertilo Wennergren -
http://html5doctor.com/cite-and-blockquote-reloaded/#comment-38774

"It seems to me that the wording in the spec should be:

“It is suggested that if the ‘footer’ or ‘cite’ elements are included and these elements are also being used within a ‘blockquote’ to identify citations, ‘i’ elements should be substitued for the ‘cite’ elements from the quoted source, and ‘div’ elements substituted for the ‘footer’ elements from the quoted source. The original mark-up (using ‘cite’ and/or ‘footer’) can be retained in comments.”

The part about “div” for “footer” is my own conjecture."
Comment 16 Nicholas Stimpson 2013-11-05 11:08:39 UTC
(In reply to steve faulkner from comment #15)
> comment from bertilo Wennergren -
> http://html5doctor.com/cite-and-blockquote-reloaded/#comment-38774
> 
> "It seems to me that the wording in the spec should be:
> 
> “It is suggested that if the ‘footer’ or ‘cite’ elements are included and
> these elements are also being used within a ‘blockquote’ to identify
> citations, ‘i’ elements should be substitued for the ‘cite’ elements from
> the quoted source, and ‘div’ elements substituted for the ‘footer’ elements
> from the quoted source. The original mark-up (using ‘cite’ and/or ‘footer’)
> can be retained in comments.”
> 
> The part about “div” for “footer” is my own conjecture."

The problem I have with this, is that I don't understand why a piece of content that would, in any other context be marked up with 'cite', not be marked up with 'cite' when it is in quoted text. Isn't a 'cite' just as useful there as anywhere else? 

Note that this is irrespective of whether 'cite' markup was used in the source from which the text is being quoted.
Comment 17 steve faulkner 2013-11-06 12:33:32 UTC
considering changing the suggestion in the spec to use of a class attribute (a defined extensibility mechanism) on the cite element to identify it as an inclusion from the quoted source:

  <blockquote>
  <p>My favorite book is <cite class="from-quote">At Swim-Two-Birds</cite></p>
  <footer>- <cite>Mike[tm]Smith</cite></footer>
  </blockquote>

thoughts?
Comment 18 steve faulkner 2013-11-06 12:35:42 UTC
(In reply to steve faulkner from comment #17)
> considering changing the suggestion in the spec to use of a class attribute
> (a defined extensibility mechanism) on the cite element to identify it as an
> inclusion from the quoted source:
> 
>   <blockquote>
>   <p>My favorite book is <cite class="from-quote">At
> Swim-Two-Birds</cite></p>
>   <footer>- <cite>Mike[tm]Smith</cite></footer>
>   </blockquote>
> 
> thoughts?

re (a defined extensibility mechanism) see http://www.w3.org/html/wg/drafts/html/master/infrastructure.html#extensibility
Comment 19 github bugzilla bot 2013-11-08 14:04:22 UTC
Commit pushed to master at https://github.com/w3c/html

https://github.com/w3c/html/commit/fcd92cd02803e3a1939a8b18e64c40e4149fbb13
updated advice on source cite within bquote

refer to http://html5doctor.com/cite-and-blockquote-reloaded/ and
bug 23175
Comment 20 steve faulkner 2014-01-12 16:31:08 UTC
EDITOR'S RESPONSE: This is an Editor's Response to your comment. If you are
satisfied with this response, please change the state of this bug to CLOSED. If
you have additional information and would like the Editor to reconsider, please
reopen this bug. If you would like to escalate the issue to the full HTML
Working Group, please add the TrackerRequest keyword to this bug, and suggest
title and text for the Tracker Issue; or you may create a Tracker Issue
yourself, if you are able to do so. For more details, see this document:

   http://dev.w3.org/html5/decision-policy/decision-policy.html

Status: Accepted
Change Description: see Comment 19
Rationale: made changes to how source code in quotes is denoted, no further comment so closing.
Comment 21 github bugzilla bot 2014-01-16 15:10:34 UTC
Commits pushed to CR at https://github.com/w3c/html

https://github.com/w3c/html/commit/fa08747b366b40e9942d29f071dccb33ea5529d2
what to do when cite in quoted source

https://github.com/w3c/html/commit/fcd92cd02803e3a1939a8b18e64c40e4149fbb13
updated advice on source cite within bquote